// VidzRadioProdTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VidzRadioProdTest.h"
#include "VidzRadioProdTestDlg.h"
#include "ColorStaticST.h"
#include <mmsystem.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	CVRLib*	m_pAbtDlgLib;

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CString	Display;
	int		iSwVer1, iSwVer2, iSwVer3, iDllVer1, iDllVer2, iDllVer3;

	iSwVer1 = (SOFTWARE_VERSION/100)%10;
	iSwVer2 = (SOFTWARE_VERSION/10)%10;
	iSwVer3 = (SOFTWARE_VERSION/1)%10;
	Display.Format("USB Radio Xtreme production testing\nSoftware Version %d.%d.%d", iSwVer1, iSwVer2, iSwVer3);
	SetDlgItemText(IDC_SOFTWARE_VER, Display);

	m_pAbtDlgLib->GetDLLVer(&iDllVer1, &iDllVer2, &iDllVer3);
	Display.Format("VRLib DLL Version %d.%d.%d", iDllVer1, iDllVer2, iDllVer3);
	SetDlgItemText(IDC_DLL_VERSION, Display);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CVidzRadioProdTestDlg dialog

CVidzRadioProdTestDlg::CVidzRadioProdTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVidzRadioProdTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVidzRadioProdTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	// Initialize variables
	m_pLib			= NULL;
	m_uiPresetFreq	= 0;
	m_uiSenStaFreq1	= 0;
	m_uiSenStaFreq2 = 0;
	m_uiSenStaFreq3 = 0;
	m_uiSrFrequency	= 0;
	m_uiSrDirection	= 0;
	m_uiRemoteChoice= 0;
	m_uiCurFirmVer	= 0;
	m_bDataLoaded	= FALSE;
	m_bAutoTest		= FALSE;
	m_bEnableSound	= FALSE;
	m_iATCount		= 0;
	m_bAutoTestStarted = FALSE;
	m_iSearchCount	= 0;
	m_dwLastIRCode	= 0;
	m_bTestStarted	= FALSE;
	// Set all test bool variables to the false state
	m_bTuneTest		= FALSE;
	m_bSTPinTest	= FALSE;
	m_bSenTest		= FALSE;
	m_bSearchTest	= FALSE;
	m_bAuLeftTest	= FALSE;
	m_bAuRightTest	= FALSE;
	m_bAuBothTest	= FALSE;
	m_bLEDGreen		= FALSE;
	m_bLEDRed		= FALSE;
	m_bRCTest		= FALSE;
	m_bAllTestDone	= FALSE;
	// Load the IR code for the button in the array
	m_dwBtnCode[0] = 0x12;
	m_dwBtnCode[1] = 0x13;
	m_dwBtnCode[2] = 0x05;
	m_dwBtnCode[3] = 0x08;
	m_dwBtnCode[4] = 0x09;
	m_dwBtnCode[5] = 0x0A;
	m_dwBtnCode[6] = 0x0B;
	m_dwBtnCode[7] = 0x0C;
	m_dwBtnCode[8] = 0x0D;
	m_dwBtnCode[9] = 0x0E;
	m_dwBtnCode[10] = 0x0F;
	m_dwBtnCode[11] = 0x10;
	m_dwBtnCode[12] = 0x06;
	m_dwBtnCode[13] = 0x07;
	m_dwBtnCode[14] = 0x11;
	m_dwBtnCode[15] = 0x1C;
	m_dwBtnCode[16] = 0x1D;
	m_dwBtnCode[17] = 0x1E;
	m_dwBtnCode[18] = 0x18;
	m_dwBtnCode[19] = 0x16;
	m_dwBtnCode[20] = 0x1F;
	m_dwBtnCode[21] = 0x19;
	m_dwBtnCode[22] = 0x1A;
	m_dwBtnCode[23] = 0x1B;
	m_dwBtnCode[24] = 0x04;
	m_dwBtnCode[25] = 0x17;
	m_dwBtnCode[26] = 0x03;
	m_dwBtnCode[27] = 0x15;
	m_dwBtnCode[28] = 0x00;
	m_dwBtnCode[29] = 0x14;
	m_dwBtnCode[30] = 0x01;
	m_dwBtnCode[31] = 0x02;
}

void CVidzRadioProdTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVidzRadioProdTestDlg)
	DDX_Control(pDX, IDC_STPIN_RS, m_stcSTPinRS);
	DDX_Control(pDX, IDC_SENSTA1_RS, m_stcSenSta1RS);
	DDX_Control(pDX, IDC_SENSTA2_RS, m_stcSenSta2RS);
	DDX_Control(pDX, IDC_SENSTA3_RS, m_stcSenSta3RS);
	DDX_Control(pDX, IDC_TUNETEST_RS, m_stcTuneTestRS);
	DDX_Control(pDX, IDC_DEVICE, m_csDevice);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVidzRadioProdTestDlg, CDialog)
	//{{AFX_MSG_MAP(CVidzRadioProdTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_INITIALIZE, OnInitialize)
	ON_COMMAND(IDM_SETTINGS_CONFIG, OnSettingsConfig)
	ON_COMMAND(IDM_HELP_ABOUT, OnHelpAbout)
	ON_BN_CLICKED(IDC_QUIT, OnQuit)
	ON_BN_CLICKED(IDC_TUNE_TEST, OnTuneTest)
	ON_BN_CLICKED(IDC_STPIN_TEST, OnStereoPinTest)
	ON_BN_CLICKED(IDC_SENSITIVE_TEST, OnSensitivityTest)
	ON_BN_CLICKED(IDC_SEARCH_TEST, OnSearchTest)
	ON_BN_CLICKED(IDC_AU_L, OnAudioLeft)
	ON_BN_CLICKED(IDC_AU_R, OnAudioRight)
	ON_BN_CLICKED(IDC_AU_LR, OnAudioLeftAndRight)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_RC_NTDETECTED, OnRcNtDetected)
	ON_BN_CLICKED(IDC_LED_GREEN, OnLedGreen)
	ON_BN_CLICKED(IDC_LED_RED, OnLedRed)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVidzRadioProdTestDlg message handlers

BOOL CVidzRadioProdTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	// Preset firmware version to 0.0
	SetDlgItemText(IDC_FIRMWARE_VER, "0.0");
	// Disable all test buttons
	SetTestButtons(FALSE);
	// Call function to load data from ini file
	ReadWriteTestData(TRUE);
	// If all data is loaded, then pass data to preset settings dialog
	if(m_bDataLoaded)
	{
		m_dlgSettings.m_uiPresetFreq	= m_uiPresetFreq;
		m_dlgSettings.m_uiSenStaFreq1	= m_uiSenStaFreq1;
		m_dlgSettings.m_uiSenStaFreq2	= m_uiSenStaFreq2;
		m_dlgSettings.m_uiSenStaFreq3	= m_uiSenStaFreq3;
		m_dlgSettings.m_uiSrFrequency	= m_uiSrFrequency;
		m_dlgSettings.m_uiSrDirection	= m_uiSrDirection;
		m_dlgSettings.m_uiRemoteChoice	= m_uiRemoteChoice;
		m_dlgSettings.m_uiCurFirmVer	= m_uiCurFirmVer;
		m_dlgSettings.m_bAutoTest		= m_bAutoTest;
		m_dlgSettings.m_bEnableSound	= m_bEnableSound;
		m_dlgSettings.m_bEnableRC		= m_bEnableRC;
	}
	
	// If remote control is enabled in test, initialize radio device
	if(m_bEnableRC)
	{
		// Create a new CVRLib object
		if(m_pLib == NULL)
			m_pLib = new CVRLib;
		
		if(m_pLib->Initialize())
		{
			SetTimer(TM_READIR, 400, NULL);
			GetDlgItem(IDC_RC_RS)->EnableWindow(FALSE);
		}
	}
	
	// Create the mixer object so that we can control the mixer balance
	CreateMixerObj();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVidzRadioProdTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVidzRadioProdTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVidzRadioProdTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVidzRadioProdTestDlg::OnSettingsConfig() 
{
	if(m_dlgSettings.DoModal() == IDOK)
	{
		// If the OK button is pressed in the settings dialog,
		// update the variables in test dialog
		m_uiPresetFreq	= m_dlgSettings.m_uiPresetFreq;
		m_uiSenStaFreq1	= m_dlgSettings.m_uiSenStaFreq1;
		m_uiSenStaFreq2	= m_dlgSettings.m_uiSenStaFreq2;
		m_uiSenStaFreq3	= m_dlgSettings.m_uiSenStaFreq3;
		m_uiSrFrequency	= m_dlgSettings.m_uiSrFrequency;
		m_uiSrDirection	= m_dlgSettings.m_uiSrDirection;
		m_uiRemoteChoice= m_dlgSettings.m_uiRemoteChoice;
		m_uiCurFirmVer	= m_dlgSettings.m_uiCurFirmVer;
		m_bAutoTest		= m_dlgSettings.m_bAutoTest;
		m_bEnableSound	= m_dlgSettings.m_bEnableSound;
		m_bEnableRC		= m_dlgSettings.m_bEnableRC;

		// Display the data on dialog box
		UpdateTestData();

		// If all data are loaded and remote control is enabled for test
		// start the readIR loop
		if(m_bDataLoaded)
		{
			if(m_bEnableRC)
			{
				// Create a new CVRLib object
				if(m_pLib == NULL)
					m_pLib = new CVRLib;
			
				if(m_pLib->Initialize())
				{
					SetTimer(TM_READIR, 400, NULL);
					// Disable remote control result text
					GetDlgItem(IDC_RC_RS)->EnableWindow(FALSE);
				}
			}
			else
			{
				// To be safe, we stop the timer that reads the IR code
				KillTimer(TM_READIR);
				// Enable remote control result text
				GetDlgItem(IDC_RC_RS)->EnableWindow(TRUE);
			}
		}
	}
}

void CVidzRadioProdTestDlg::OnHelpAbout() 
{
	// Display the about dialog
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void CVidzRadioProdTestDlg::OnInitialize() 
{
	HICON	hiDev;
	DWORD	dwFmVer1, dwFmVer2;
	UINT	uiFmVer;
	TCHAR	tcFmVer[MAX_PATH];
	CString	csInit;
		
	GetDlgItemText(IDC_INITIALIZE, csInit);
	csInit.Remove('&');
	// Test to see in which state is the Initialize button
	if(csInit.Compare("Initialize") == 0)
	{
		// Before initializing

		// Create a new CVRLib object
		if(m_pLib == NULL)
			m_pLib = new CVRLib;
		
		// Test if we can detect the device and load the corresponding icon
		if(m_pLib->Initialize())
		{
			// Change text on Initilize button
			SetDlgItemText(IDC_INITIALIZE, "UnInitialize");
			// Get current firmware version of device
			m_pLib->GetFirmwareVer(&dwFmVer1, &dwFmVer2);
			wsprintf(tcFmVer, "%d.%d", dwFmVer1, dwFmVer2);
			uiFmVer = (UINT) (dwFmVer1*10) + dwFmVer2;
			SetDlgItemText(IDC_FIRMWARE_VER, tcFmVer);
			// Test to see if firmware version is same. If not, reset to starting state
			if(m_uiCurFirmVer != uiFmVer)
			{
				CString msg;
				UINT	uiReqFmVer1, uiReqFmVer2;

				uiReqFmVer1 = (m_uiCurFirmVer/10)%10;
				uiReqFmVer2 = (m_uiCurFirmVer)%10;

				msg.Format("Required firmware version is %d.%d. Detected firmware version is different.\nProgram uninitializing......",
							uiReqFmVer1, uiReqFmVer2);
				
				MessageBox(msg, "Error", MB_OK|MB_ICONEXCLAMATION|MB_SETFOREGROUND);
				SetDlgItemText(IDC_INITIALIZE, "Initialize");
				// Reset firmware version
				SetDlgItemText(IDC_FIRMWARE_VER, "0.0");
											
				return;
			}

			// Update bool variable to indicate test has started
			m_bTestStarted = TRUE;
						
			// Reset volume balance to center
			SetMixerBal(CENTER);
			SetDlgItemText(IDC_VOL_BAL, "Left and Right");
			// Set LED to red color and Display LED State
			m_pLib->SetLEDRed();
			SetDlgItemText(IDC_LED_STATE, "LED Red");
			// If test data loaded and the READIR timer has not yet been started
			if(m_bDataLoaded && !m_bEnableRC)
				// Start the IR reading timer
				SetTimer(TM_READIR, 400, NULL);
			// Test if remote control is enabled for test. If yes, then disable RC test results
			if(m_bEnableRC)
				GetDlgItem(IDC_RC_RS)->EnableWindow(FALSE);
			// Load found device icon
			hiDev = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_DEV_YES));
			m_csDevice.SetIcon(hiDev);
			if(m_bAutoTest)
			{
				// Disable all buttons
				GetDlgItem(IDC_INITIALIZE)->EnableWindow(FALSE);
				SetTestButtons(FALSE);
				// Disable the readIR Timer
				KillTimer(TM_READIR);
				// Set other variables
				m_bAutoTestStarted = TRUE;				
				SetTimer(TM_AUTOTEST, 100, NULL);
			}
			// Enable test buttons
			SetTestButtons(TRUE);
			GetDlgItem(IDC_QUIT)->EnableWindow(FALSE);
		}
		else
		{
			// Disable all windows
			GetDlgItem(IDC_INITIALIZE)->EnableWindow(FALSE);
			GetDlgItem(IDC_QUIT)->EnableWindow(FALSE);
			// Load device not found icon
			hiDev = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_DEV_NO));
			m_csDevice.SetIcon(hiDev);
						
			// Wait for a while and reset device detection icon
			Sleep(2000);
			hiDev = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_DEV_BLANK));
			m_csDevice.SetIcon(hiDev);
			GetDlgItem(IDC_INITIALIZE)->EnableWindow(TRUE);
			GetDlgItem(IDC_QUIT)->EnableWindow(TRUE);
		}
	}
	else
	{
		// After initialization

		// Test if all test are done, if not, exit function
		if(!m_bAllTestDone)
		{
			MessageBox("Not all tests are completed. Please perform all test before exiting.",
				"Alert", MB_OK|MB_ICONINFORMATION|MB_SETFOREGROUND);
			return;
		}

		// Update bool variable to indicate that test has ended
		m_bTestStarted = FALSE;
			
		// Change text on Initilize button
		SetDlgItemText(IDC_INITIALIZE, "Initialize");
		
		// If test data loaded and remote control is not enabled
		if(m_bDataLoaded && !m_bEnableRC)
			// Stop the IR reading timer
			KillTimer(TM_READIR);
		// Uninitialize radio device
		if(m_pLib)
			m_pLib->MuteVolume();
				
		// Reset all test results
		SetDlgItemText(IDC_TUNETEST_RS, "Not Tested");
		SetDlgItemText(IDC_STPIN_RS, "Not Tested");
		SetDlgItemText(IDC_SENSTA1_RS, "Not Tested");
		SetDlgItemText(IDC_SENSTA2_RS, "Not Tested");
		SetDlgItemText(IDC_SENSTA3_RS, "Not Tested");
		SetDlgItemText(IDC_VOL_BAL, "");
		SetDlgItemText(IDC_LED_STATE, "");
		// Reset LED state to red color
		m_pLib->SetLEDRed();
		// Reset all test results text color to black
		m_stcTuneTestRS.SetTextColor(RGB(0,0,0));
		m_stcSTPinRS.SetTextColor(RGB(0,0,0));
		m_stcSenSta1RS.SetTextColor(RGB(0,0,0));
		m_stcSenSta2RS.SetTextColor(RGB(0,0,0));
		m_stcSenSta3RS.SetTextColor(RGB(0,0,0));
		// Reset all test result to stop blinking if they are
		m_stcTuneTestRS.StartTextBlink(FALSE, CColorStaticST::ST_FLS_NORMAL);
		m_stcSTPinRS.StartTextBlink(FALSE, CColorStaticST::ST_FLS_NORMAL);
		m_stcSenSta1RS.StartTextBlink(FALSE, CColorStaticST::ST_FLS_NORMAL);
		m_stcSenSta2RS.StartTextBlink(FALSE, CColorStaticST::ST_FLS_NORMAL);
		m_stcSenSta3RS.StartTextBlink(FALSE, CColorStaticST::ST_FLS_NORMAL);
		// Reset all test bool
		m_bTuneTest		= FALSE;
		m_bSTPinTest	= FALSE;
		m_bSenTest		= FALSE;
		m_bSearchTest	= FALSE;
		m_bAuLeftTest	= FALSE;
		m_bAuRightTest	= FALSE;
		m_bAuBothTest	= FALSE;
		m_bLEDGreen		= FALSE;
		m_bLEDRed		= FALSE;
		m_bRCTest		= FALSE;
		m_bAllTestDone	= FALSE;

		if(m_bDataLoaded)
		{
			// Show the searching direction
			if(m_uiSrDirection == 0)
				SetDlgItemText(IDC_SEARCH_RS, "Search Up");
			else if(m_uiSrDirection == 1)
				SetDlgItemText(IDC_SEARCH_RS, "Search Down");

			// Reset search count
			m_iSearchCount = 0;

			// Display the button we are testing
			DisplayRCMessage(m_uiRemoteChoice);
		}
		
		// Reset the device detection icon
		hiDev = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_DEV_BLANK));
		m_csDevice.SetIcon(hiDev);
		
		// Reset firmware version
		SetDlgItemText(IDC_FIRMWARE_VER, "0.0");
		// Enable test buttons
		SetTestButtons(FALSE);
		GetDlgItem(IDC_QUIT)->EnableWindow(TRUE);
	}
}

void CVidzRadioProdTestDlg::OnTuneTest() 
{
	DWORD	dwActualFreq;
	
	// Diable all test buttons till test is finished
	SetTestButtons(FALSE);
	
	// Stop text blinking if they are
	m_stcTuneTestRS.StartTextBlink(FALSE, CColorStaticST::ST_FLS_NORMAL);
	// Change text color to black
	m_stcTuneTestRS.SetTextColor(RGB(0,0,0));
	// Change test results text
	SetDlgItemText(IDC_TUNETEST_RS, "Testing...");
		
	// Prepare the data to send to radio chip
	m_pLib->SetAuFormat(STEREO);
	m_pLib->SetTuneFreq(m_uiPresetFreq);
	// Read back the frequency set. If it's the same as the preset frequency, test passed
	dwActualFreq = m_pLib->GetTuneFreq();

	if(m_uiPresetFreq == (UINT) dwActualFreq)
	{
		// Change text color to blue
		m_stcTuneTestRS.SetTextColor(RGB(0,0,255));
		SetDlgItemText(IDC_TUNETEST_RS, "Test Passed");	
	}
	else
	{
		// Set text to red and blink
		m_stcTuneTestRS.SetBlinkTextColors(RGB(255,0,0), GetSysColor(COLOR_BTNFACE));
		m_stcTuneTestRS.StartTextBlink(TRUE, CColorStaticST::ST_FLS_FAST);
		SetDlgItemText(IDC_TUNETEST_RS, "Test Failed");
	}
	
	// Set test bool variable to true
	m_bTuneTest = TRUE;
	m_bAllTestDone = ProbeAllTestStates();

	// Play the sound according to test results
	PlayTestResultSound(IDC_TUNETEST_RS);

	// Enable test buttons
	SetTestButtons(TRUE);
}

void CVidzRadioProdTestDlg::OnStereoPinTest() 
{
	SHORT	sResult;
	
	// Diable all test buttons till test is finished
	SetTestButtons(FALSE);

	// Stop text blinking if they are
	m_stcSTPinRS.StartTextBlink(FALSE, CColorStaticST::ST_FLS_NORMAL);
	// Change text color to black
	m_stcSTPinRS.SetTextColor(RGB(0,0,0));
	// Change test results text
	SetDlgItemText(IDC_STPIN_RS, "Testing...");
	
	// This test involves sending a mute command and test if the AudioFormat is MONO
	// If yes, the test passed, else failed.
	m_pLib->MuteVolume();
	Sleep(500);
	sResult = m_pLib->GetAuFormat();
	if(sResult == MONO)
	{
		// Change text color to blue
		m_stcSTPinRS.SetTextColor(RGB(0,0,255));
		SetDlgItemText(IDC_STPIN_RS, "Test Passed");		
	}
	else
	{
		// Set text to red and blink
		m_stcSTPinRS.SetBlinkTextColors(RGB(255,0,0), GetSysColor(COLOR_BTNFACE));
		m_stcSTPinRS.StartTextBlink(TRUE, CColorStaticST::ST_FLS_FAST);
		SetDlgItemText(IDC_STPIN_RS, "Test Failed");
	}
	
	// Set test bool variable to true
	m_bSTPinTest = TRUE;
	m_bAllTestDone = ProbeAllTestStates();

	// Play the sound according to test results
	PlayTestResultSound(IDC_STPIN_RS);

	m_pLib->UnMuteVolume();
	// Enable test buttons
	SetTestButtons(TRUE);
}


void CVidzRadioProdTestDlg::OnSensitivityTest() 
{
	SHORT	sResult;
	CString	csTestResult;
	
	// Diable all test buttons till test is finished
	SetTestButtons(FALSE);

	// Stop text blinking if they are
	m_stcSenSta1RS.StartTextBlink(FALSE, CColorStaticST::ST_FLS_NORMAL);
	m_stcSenSta2RS.StartTextBlink(FALSE, CColorStaticST::ST_FLS_NORMAL);
	m_stcSenSta3RS.StartTextBlink(FALSE, CColorStaticST::ST_FLS_NORMAL);
	// Change text color to black
	m_stcSenSta1RS.SetTextColor(RGB(0,0,0));
	m_stcSenSta2RS.SetTextColor(RGB(0,0,0));
	m_stcSenSta3RS.SetTextColor(RGB(0,0,0));
	// Change test results text
	SetDlgItemText(IDC_SENSTA1_RS, "Testing...");
	SetDlgItemText(IDC_SENSTA2_RS, "Not Tested");
	SetDlgItemText(IDC_SENSTA3_RS, "Not Tested");
	
	// Perform a stereo sensitivity test for 1st frequecny 
	m_pLib->SetTuneFreq(m_uiSenStaFreq1);
	Sleep(2000);
	sResult = m_pLib->GetAuFormat();
	if(sResult == STEREO)
	{
		// Change text color to blue
		m_stcSenSta1RS.SetTextColor(RGB(0,0,255));
		SetDlgItemText(IDC_SENSTA1_RS, "Test Passed");
	}
	else
	{
		// Set text to red
		m_stcSenSta1RS.SetTextColor(RGB(255,0,0));
		SetDlgItemText(IDC_SENSTA1_RS, "Test Failed");
	}
	PlayTestResultSound(IDC_SENSTA1_RS);
	
	// Perform a stereo sensitivity test for 2nd frequecny 
	SetDlgItemText(IDC_SENSTA2_RS, "Testing...");
	m_pLib->SetTuneFreq(m_uiSenStaFreq2);
	Sleep(2000);
	sResult = m_pLib->GetAuFormat();
	if(sResult == STEREO)
	{
		// Change text color to blue
		m_stcSenSta2RS.SetTextColor(RGB(0,0,255));
		SetDlgItemText(IDC_SENSTA2_RS, "Test Passed");		
	}
	else
	{
		// Set text to red
		m_stcSenSta2RS.SetTextColor(RGB(255,0,0));
		SetDlgItemText(IDC_SENSTA2_RS, "Test Failed");
	}
	PlayTestResultSound(IDC_SENSTA2_RS);
	
	// Perform a stereo sensitivity test for 3rd frequecny 	
	SetDlgItemText(IDC_SENSTA3_RS, "Testing...");
	m_pLib->SetTuneFreq(m_uiSenStaFreq3);
	Sleep(2000);
	sResult = m_pLib->GetAuFormat();
	if(sResult == STEREO)
	{
		// Change text color to blue
		m_stcSenSta3RS.SetTextColor(RGB(0,0,255));
		SetDlgItemText(IDC_SENSTA3_RS, "Test Passed");		
	}
	else
	{
		// Set text to red
		m_stcSenSta3RS.SetTextColor(RGB(255,0,0));
		SetDlgItemText(IDC_SENSTA3_RS, "Test Failed");		
	}
	// Play the sound according to test results
	PlayTestResultSound(IDC_SENSTA3_RS);

	// Check tests results. If failed, set text to blink
	GetDlgItemText(IDC_SENSTA1_RS, csTestResult);
	if(csTestResult.Compare("Test Failed") == 0)
	{
		m_stcSenSta1RS.SetBlinkTextColors(RGB(255,0,0), GetSysColor(COLOR_BTNFACE));
		m_stcSenSta1RS.StartTextBlink(TRUE, CColorStaticST::ST_FLS_FAST);
	}
	GetDlgItemText(IDC_SENSTA2_RS, csTestResult);
	if(csTestResult.Compare("Test Failed") == 0)
	{
		m_stcSenSta2RS.SetBlinkTextColors(RGB(255,0,0), GetSysColor(COLOR_BTNFACE));
		m_stcSenSta2RS.StartTextBlink(TRUE, CColorStaticST::ST_FLS_FAST);
	}
	GetDlgItemText(IDC_SENSTA3_RS, csTestResult);
	if(csTestResult.Compare("Test Failed") == 0)
	{
		m_stcSenSta3RS.SetBlinkTextColors(RGB(255,0,0), GetSysColor(COLOR_BTNFACE));
		m_stcSenSta3RS.StartTextBlink(TRUE, CColorStaticST::ST_FLS_FAST);
	}

	// Set test bool variable to true
	m_bSenTest = TRUE;
	m_bAllTestDone = ProbeAllTestStates();

	// Enable test buttons
	SetTestButtons(TRUE);
}

void CVidzRadioProdTestDlg::OnSearchTest() 
{
	//DWORD	dwFoundFreq;
	CString	csDisplay;
	
	// Diable all test buttons till test is finished
	SetTestButtons(FALSE);

	// Increament the search counter
	m_iSearchCount++;

	// Change test results text
	SetDlgItemText(IDC_SEARCH_RS, "Testing...");
	
	// If search test is performed for the first time
	if(m_iSearchCount == 1)
	{
		// Preset to the starting frequency first
		m_pLib->SetTuneFreq(m_uiSrFrequency);
		m_dwNewSearchFreq = m_uiSrFrequency;
		Sleep(500);
	}
	
	// Change test results text
	SetDlgItemText(IDC_SEARCH_RS, "Searching...");

	if(m_uiSrDirection == 0)
		m_dwNewSearchFreq = m_pLib->StartSearch(UP, m_dwNewSearchFreq);
	else if(m_uiSrDirection == 1)
			m_dwNewSearchFreq = m_pLib->StartSearch(DOWN, m_dwNewSearchFreq);

	csDisplay.Format("Found: %d Mhz", m_dwNewSearchFreq);
	csDisplay.Insert((csDisplay.GetLength()-6), '.');
	SetDlgItemText(IDC_SEARCH_RS, csDisplay);

	// Set test bool variable to true
	m_bSearchTest = TRUE;
	m_bAllTestDone = ProbeAllTestStates();
	
	SetTestButtons(TRUE);
}

void CVidzRadioProdTestDlg::OnAudioLeft() 
{
	SetMixerBal(LEFT);
	SetDlgItemText(IDC_VOL_BAL, "Left Only");
	// Set test bool variable to true
	m_bAuLeftTest = TRUE;
	m_bAllTestDone = ProbeAllTestStates();
}

void CVidzRadioProdTestDlg::OnAudioRight() 
{
	SetMixerBal(RIGHT);
	SetDlgItemText(IDC_VOL_BAL, "Right Only");
	// Set test bool variable to true
	m_bAuRightTest = TRUE;
	m_bAllTestDone = ProbeAllTestStates();
}

void CVidzRadioProdTestDlg::OnAudioLeftAndRight() 
{
	SetMixerBal(CENTER);
	SetDlgItemText(IDC_VOL_BAL, "Left and Right");
	// Set test bool variable to true
	m_bAuBothTest = TRUE;
	m_bAllTestDone = ProbeAllTestStates();
}

void CVidzRadioProdTestDlg::OnLedGreen() 
{
	m_pLib->SetLEDGreen();
	SetDlgItemText(IDC_LED_STATE, "LED Green");
	// Set test bool variable to true
	m_bLEDGreen = TRUE;
	m_bAllTestDone = ProbeAllTestStates();
}

void CVidzRadioProdTestDlg::OnLedRed() 
{
	m_pLib->SetLEDRed();
	SetDlgItemText(IDC_LED_STATE, "LED Red");
	m_bLEDRed = TRUE;
	// Set test bool variable to true
	m_bAllTestDone = ProbeAllTestStates();
}

void CVidzRadioProdTestDlg::OnTimer(UINT nIDEvent)
{
	DWORD	dwIRCode;
	
	switch(nIDEvent)
	{
	case TM_READIR:

		// Retrieve IR code from radio chip
		dwIRCode = m_pLib->GetIRCode();

		// If remote control is enable in test, map buttons to test functions
		if(m_bEnableRC)
		{
			// The condition loop here filter out excessive IR codes
			if(m_dwLastIRCode == dwIRCode)
			{
				m_dwLastIRCode = dwIRCode;
				dwIRCode = 0xFFFE;
			}

			// See which button on the remote control is pressed
			// Note that for the first case, there is no if condition loop unlike 
			// all other cases. This is to let the application allow only the first
			// function to execute before the test starts i.e. before the user
			// press the "Initialize " button.
			switch(dwIRCode)
			{
			case 0x05:
				m_bRCTest = TRUE;
				m_bAllTestDone = ProbeAllTestStates();
				OnInitialize();
				break;
			case 0x08:
				if(!m_bTestStarted)
					return;
				m_bRCTest = TRUE;
				m_bAllTestDone = ProbeAllTestStates();
				OnTuneTest();
				break;
			case 0x09:
				if(!m_bTestStarted)
					return;
				m_bRCTest = TRUE;
				m_bAllTestDone = ProbeAllTestStates();
				OnStereoPinTest();
				break;
			case 0x0A:
				if(!m_bTestStarted)
					return;
				m_bRCTest = TRUE;
				m_bAllTestDone = ProbeAllTestStates();
				OnSensitivityTest();
				break;
			case 0x0B:
				if(!m_bTestStarted)
					return;
				m_bRCTest = TRUE;
				m_bAllTestDone = ProbeAllTestStates();
				OnSearchTest();
				break;
			case 0x0C:
				if(!m_bTestStarted)
					return;
				m_bRCTest = TRUE;
				m_bAllTestDone = ProbeAllTestStates();
				OnAudioLeft();
				break;
			case 0x0D:
				if(!m_bTestStarted)
					return;
				m_bRCTest = TRUE;
				m_bAllTestDone = ProbeAllTestStates();
				OnAudioRight();
				break;
			case 0x0E:
				if(!m_bTestStarted)
					return;
				m_bRCTest = TRUE;
				m_bAllTestDone = ProbeAllTestStates();
				OnAudioLeftAndRight();
				break;
			case 0x0F:
				if(!m_bTestStarted)
					return;
				m_bRCTest = TRUE;
				m_bAllTestDone = ProbeAllTestStates();
				OnLedGreen();
				break;
			case 0x10:
				if(!m_bTestStarted)
					return;
				m_bRCTest = TRUE;
				m_bAllTestDone = ProbeAllTestStates();
				OnLedRed();
				break;
			case 0x13:
				if(!m_bTestStarted)
					return;
				m_bRCTest = TRUE;
				m_bAllTestDone = ProbeAllTestStates();
				// This button clears the warning message on the screen.
				HWND	hPopup;
				hPopup = ::FindWindow(NULL, "Alert");
				::SetForegroundWindow(hPopup);
				keybd_event(VK_RETURN, 0, 0, 0);
				keybd_event(VK_RETURN, 0, KEYEVENTF_KEYUP, 0);
				break;
			}

			// If the user didn't hold the button
			if(dwIRCode != 0xFFFE)
				// Store the last used IR code
				m_dwLastIRCode = dwIRCode;
		}
		// else display which button is detected
		else if(dwIRCode == m_dwBtnCode[m_uiRemoteChoice])
		{
			if(m_bEnableRC)
				return;
			
			// Set test bool variable to true
			m_bRCTest = TRUE;
			m_bAllTestDone = ProbeAllTestStates();
			switch(m_uiRemoteChoice)
			{
			case 0:
				SetDlgItemText(IDC_RC_RS, "'Mute' button detected");
				break;
			case 1:
				SetDlgItemText(IDC_RC_RS, "'TV/FM' button detected");
				break;
			case 2:
				SetDlgItemText(IDC_RC_RS, "'Power' button detected");
				break;
			case 3:
				SetDlgItemText(IDC_RC_RS, "'1' button detected");
				break;
			case 4:
				SetDlgItemText(IDC_RC_RS, "'2' button detected");
				break;
			case 5:
				SetDlgItemText(IDC_RC_RS, "'3' button detected");
				break;
			case 6:
				SetDlgItemText(IDC_RC_RS, "'4' button detected");
				break;
			case 7:
				SetDlgItemText(IDC_RC_RS, "'5' button detected");
				break;
			case 8:
				SetDlgItemText(IDC_RC_RS, "'6' button detected");
				break;
			case 9:
				SetDlgItemText(IDC_RC_RS, "'7' button detected");
				break;
			case 10:
				SetDlgItemText(IDC_RC_RS, "'8' button detected");
				break;
			case 11:
				SetDlgItemText(IDC_RC_RS, "'9' button detected");
				break;
			case 12:
				SetDlgItemText(IDC_RC_RS, "'10' button detected");
				break;
			case 13:
				SetDlgItemText(IDC_RC_RS, "'11' button detected");
				break;
			case 14:
				SetDlgItemText(IDC_RC_RS, "'12' button detected");
				break;
			case 15:
				SetDlgItemText(IDC_RC_RS, "'P1' button detected");
				break;
			case 16:
				SetDlgItemText(IDC_RC_RS, "'P2' button detected");
				break;
			case 17:
				SetDlgItemText(IDC_RC_RS, "'P3' button detected");
				break;
			case 18:
				SetDlgItemText(IDC_RC_RS, "'P4' button detected");
				break;
			case 19:
				SetDlgItemText(IDC_RC_RS, "'P5' button detected");
				break;
			case 20:
				SetDlgItemText(IDC_RC_RS, "'P6' button detected");
				break;
			case 21:
				SetDlgItemText(IDC_RC_RS, "'Get!' button detected");
				break;
			case 22:
				SetDlgItemText(IDC_RC_RS, "'On/Off' button detected");
				break;
			case 23:
				SetDlgItemText(IDC_RC_RS, "'Enter' button detected");
				break;
			case 24:
				SetDlgItemText(IDC_RC_RS, "'Slow Rewind' button detected");
				break;
			case 25:
				SetDlgItemText(IDC_RC_RS, "'Record' button detected");
				break;
			case 26:
				SetDlgItemText(IDC_RC_RS, "'Slow Forward' button detected");
				break;
			case 27:
				SetDlgItemText(IDC_RC_RS, "'Fast Rewind' button detected");
				break;
			case 28:
				SetDlgItemText(IDC_RC_RS, "'Stop/Pause' button detected");
				break;
			case 29:
				SetDlgItemText(IDC_RC_RS, "'Fast Forward' button detected");
				break;
			case 30:
				SetDlgItemText(IDC_RC_RS, "'Volume Up' button detected");
				break;
			case 31:
				SetDlgItemText(IDC_RC_RS, "'Volume Down' button detected");
				break;
			}// switch(m_uiRemoteChoice)
			Sleep(400);
			DisplayRCMessage(m_uiRemoteChoice);
		}// if(dwIRCode == m_dwBtnCode[m_uiRemoteChoice])
		break;	// case TM_READIR
	case TM_AUTOTEST:
		// Increase AutoTest counter to keep track of which test to perform
		m_iATCount++;
		// Algorithm of autotest is to stop the counter on all tests, perform the test
		// and then restart the counter. This is to prevent conflicts of tests,
		// i.e. one test starting before the previous one has finished.
		switch(m_iATCount)
		{
		case 1:
			KillTimer(TM_AUTOTEST);
			OnTuneTest();
			SetTimer(TM_AUTOTEST, 500, NULL);
			break;
		case 2:
			KillTimer(TM_AUTOTEST);
			OnStereoPinTest();
			SetTimer(TM_AUTOTEST, 500, NULL);
			break;
		case 3:
			KillTimer(TM_AUTOTEST);
			OnSensitivityTest();
			SetTimer(TM_AUTOTEST, 500, NULL);
			break;
		case 4:
			KillTimer(TM_AUTOTEST);
			OnSearchTest();
			SetTimer(TM_AUTOTEST, 1000, NULL);
			break;
		case 5:
			KillTimer(TM_AUTOTEST);
			OnAudioLeft();
			SetTimer(TM_AUTOTEST, 2000, NULL);
			break;
		case 6:
			KillTimer(TM_AUTOTEST);
			OnAudioRight();
			SetTimer(TM_AUTOTEST, 2000, NULL);
			break;
		case 7:
			KillTimer(TM_AUTOTEST);
			OnAudioLeftAndRight();
			SetTimer(TM_AUTOTEST, 1000, NULL);
			break;
		case 8:
			KillTimer(TM_AUTOTEST);
			OnLedGreen();
			SetTimer(TM_AUTOTEST, 2000, NULL);
			break;
		case 9:
			KillTimer(TM_AUTOTEST);
			OnLedRed();
			SetTimer(TM_AUTOTEST, 1000, NULL);
			break;
		case 10:
			KillTimer(TM_AUTOTEST);
			// Restart readIR timer
			SetTimer(TM_READIR, 400, NULL);
			if(m_bEnableRC)
				MessageBox("Automatic test has completed.",
					"Alert", MB_OK|MB_ICONINFORMATION|MB_SETFOREGROUND);
			else
				MessageBox("Automatic test has completed. Please use remote control for last test.",
					"Alert", MB_OK|MB_ICONINFORMATION|MB_SETFOREGROUND);
			// Reset AutoTest variables
			m_iATCount = 0;
			m_bAutoTestStarted = FALSE;
			// Enable all buttons
			GetDlgItem(IDC_INITIALIZE)->EnableWindow(TRUE);
			SetTestButtons(TRUE);
			break;
		}// switch(m_iATCount)		
		break;	// case TM_AUTOTEST
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CVidzRadioProdTestDlg::OnRcNtDetected() 
{
	// Set test bool variable to true
	m_bRCTest = TRUE;
	m_bAllTestDone = ProbeAllTestStates();	
}

void CVidzRadioProdTestDlg::OnQuit() 
{
	OnClose();
}

void CVidzRadioProdTestDlg::OnClose() 
{
	// Save data to ini file
	ReadWriteTestData(FALSE);
	// Destroy library object
	if(m_pLib)
	{
		m_pLib->Shutdown();
		delete m_pLib;
		m_pLib = NULL;
	}
	// Close mixer object
	mixerClose(m_hmixer);
	
	OnOK();
	CDialog::OnClose();
}

void CVidzRadioProdTestDlg::SetTestButtons(BOOL bState)
{
	// If no test data loaded then cannot enable buttons	
	if(!m_bDataLoaded || m_bAutoTestStarted)
		bState = FALSE;

	GetDlgItem(IDC_TUNE_TEST)->EnableWindow(bState);
	GetDlgItem(IDC_STPIN_TEST)->EnableWindow(bState);
	GetDlgItem(IDC_SENSITIVE_TEST)->EnableWindow(bState);
	GetDlgItem(IDC_SEARCH_TEST)->EnableWindow(bState);
	GetDlgItem(IDC_AU_L)->EnableWindow(bState);
	GetDlgItem(IDC_AU_R)->EnableWindow(bState);
	GetDlgItem(IDC_AU_LR)->EnableWindow(bState);
	GetDlgItem(IDC_LED_GREEN)->EnableWindow(bState);
	GetDlgItem(IDC_LED_RED)->EnableWindow(bState);
	GetDlgItem(IDC_RC_NTDETECTED)->EnableWindow(bState);
}

void CVidzRadioProdTestDlg::DisplayRCMessage(UINT uiChoice)
{
	switch(uiChoice)
		{
		case 0:
			SetDlgItemText(IDC_RC_RS, "Testing for 'Mute' button");
			break;
		case 1:
			SetDlgItemText(IDC_RC_RS, "Testing for 'TV/FM' button");
			break;
		case 2:
			SetDlgItemText(IDC_RC_RS, "Testing for 'Power' button");
			break;
		case 3:
			SetDlgItemText(IDC_RC_RS, "Testing for '1' button");
			break;
		case 4:
			SetDlgItemText(IDC_RC_RS, "Testing for '2' button");
			break;
		case 5:
			SetDlgItemText(IDC_RC_RS, "Testing for '3' button");
			break;
		case 6:
			SetDlgItemText(IDC_RC_RS, "Testing for '4' button");
			break;
		case 7:
			SetDlgItemText(IDC_RC_RS, "Testing for '5' button");
			break;
		case 8:
			SetDlgItemText(IDC_RC_RS, "Testing for '6' button");
			break;
		case 9:
			SetDlgItemText(IDC_RC_RS, "Testing for '7' button");
			break;
		case 10:
			SetDlgItemText(IDC_RC_RS, "Testing for '8' button");
			break;
		case 11:
			SetDlgItemText(IDC_RC_RS, "Testing for '9' button");
			break;
		case 12:
			SetDlgItemText(IDC_RC_RS, "Testing for '10' button");
			break;
		case 13:
			SetDlgItemText(IDC_RC_RS, "Testing for '11' button");
			break;
		case 14:
			SetDlgItemText(IDC_RC_RS, "Testing for '12' button");
			break;
		case 15:
			SetDlgItemText(IDC_RC_RS, "Testing for 'P1' button");
			break;
		case 16:
			SetDlgItemText(IDC_RC_RS, "Testing for 'P2' button");
			break;
		case 17:
			SetDlgItemText(IDC_RC_RS, "Testing for 'P3' button");
			break;
		case 18:
			SetDlgItemText(IDC_RC_RS, "Testing for 'P4' button");
			break;
		case 19:
			SetDlgItemText(IDC_RC_RS, "Testing for 'P5' button");
			break;
		case 20:
			SetDlgItemText(IDC_RC_RS, "Testing for 'P6' button");
			break;
		case 21:
			SetDlgItemText(IDC_RC_RS, "Testing for 'Get!' button");
			break;
		case 22:
			SetDlgItemText(IDC_RC_RS, "Testing for 'On/Off' button");
			break;
		case 23:
			SetDlgItemText(IDC_RC_RS, "Testing for 'Enter' button");
			break;
		case 24:
			SetDlgItemText(IDC_RC_RS, "Testing for 'Slow Rewind' button");
			break;
		case 25:
			SetDlgItemText(IDC_RC_RS, "Testing for 'Record' button");
			break;
		case 26:
			SetDlgItemText(IDC_RC_RS, "Testing for 'Slow Forward' button");
			break;
		case 27:
			SetDlgItemText(IDC_RC_RS, "Testing for 'Fast Rewind' button");
			break;
		case 28:
			SetDlgItemText(IDC_RC_RS, "Testing for 'Stop/Pause' button");
			break;
		case 29:
			SetDlgItemText(IDC_RC_RS, "Testing for 'Fast Forward' button");
			break;
		case 30:
			SetDlgItemText(IDC_RC_RS, "Testing for 'Volume Up' button");
			break;
		case 31:
			SetDlgItemText(IDC_RC_RS, "Testing for 'Volume Down' button");
			break;
		default:
			SetDlgItemText(IDC_RC_RS, "No remote button choosen");
			break;
		}
}

void CVidzRadioProdTestDlg::ReadWriteTestData(BOOL bReadStatus)
{
	// Loading the settings.ini file
	// Defining TCHAR array to store the directory name of the ini file
	TCHAR tcFullPath[MAX_PATH+200];
	TCHAR tcIniFile[MAX_PATH+200];
	TCHAR tcWriteData[MAX_PATH];
	
	// Getting the full path name of the complied exe file
	GetModuleFileName(NULL, tcFullPath, MAX_PATH+200);
	
	// Return a pointer to where the last character "\" was found in string
	TCHAR *ptr = _tcsrchr(tcFullPath, '\\');
	*ptr = NULL;
	
	// Sets the path to the ini file
	wsprintf(tcIniFile, "%s\\TestData.ini", tcFullPath);
	
	if(bReadStatus)
	{
		// Load	the saved data before closing into program
		m_uiPresetFreq	= GetPrivateProfileInt("SAVEDDATA", "PresetFreq", 0, tcIniFile);
		m_uiSenStaFreq1	= GetPrivateProfileInt("SAVEDDATA", "SenStaFreq1", 0, tcIniFile);
		m_uiSenStaFreq2	= GetPrivateProfileInt("SAVEDDATA", "SenStaFreq2", 0, tcIniFile);
		m_uiSenStaFreq3	= GetPrivateProfileInt("SAVEDDATA", "SenStaFreq3", 0, tcIniFile);
		m_uiSrFrequency = GetPrivateProfileInt("SAVEDDATA", "SrFrequency", 0, tcIniFile);
		m_uiSrDirection = GetPrivateProfileInt("SAVEDDATA", "SrDirection", 0, tcIniFile);
		m_uiRemoteChoice = GetPrivateProfileInt("SAVEDDATA", "RemoteChoice", 0, tcIniFile);
		m_uiCurFirmVer	= GetPrivateProfileInt("SAVEDDATA", "CurrentFirmwareVersion", 0, tcIniFile);		
		m_bAutoTest		= GetPrivateProfileInt("SAVEDDATA", "AutoTest", 0, tcIniFile);
		m_bEnableSound	= GetPrivateProfileInt("SAVEDDATA", "EnableSound", 0, tcIniFile);
		m_bEnableRC		= GetPrivateProfileInt("SAVEDDATA", "EnableRC", 0, tcIniFile);
		
		UpdateTestData();
	}
	else
	{
		// Save the settings to the TestData.ini file
		wsprintf(tcWriteData, "%d", m_uiPresetFreq);
		WritePrivateProfileString("SAVEDDATA", "PresetFreq", tcWriteData, tcIniFile);
		wsprintf(tcWriteData, "%d", m_uiSenStaFreq1);
		WritePrivateProfileString("SAVEDDATA", "SenStaFreq1", tcWriteData, tcIniFile);
		wsprintf(tcWriteData, "%d", m_uiSenStaFreq2);
		WritePrivateProfileString("SAVEDDATA", "SenStaFreq2", tcWriteData, tcIniFile);
		wsprintf(tcWriteData, "%d", m_uiSenStaFreq3);
		WritePrivateProfileString("SAVEDDATA", "SenStaFreq3", tcWriteData, tcIniFile);
		wsprintf(tcWriteData, "%d", m_uiSrFrequency);
		WritePrivateProfileString("SAVEDDATA", "SrFrequency", tcWriteData, tcIniFile);
		wsprintf(tcWriteData, "%d", m_uiSrDirection);
		WritePrivateProfileString("SAVEDDATA", "SrDirection", tcWriteData, tcIniFile);
		wsprintf(tcWriteData, "%d", m_uiRemoteChoice);
		WritePrivateProfileString("SAVEDDATA", "RemoteChoice", tcWriteData, tcIniFile);
		wsprintf(tcWriteData, "%d", m_uiCurFirmVer);
		WritePrivateProfileString("SAVEDDATA", "CurrentFirmwareVersion", tcWriteData, tcIniFile);
		wsprintf(tcWriteData, "%d", m_bAutoTest);
		WritePrivateProfileString("SAVEDDATA", "AutoTest", tcWriteData, tcIniFile);
		wsprintf(tcWriteData, "%d", m_bEnableSound);
		WritePrivateProfileString("SAVEDDATA", "EnableSound", tcWriteData, tcIniFile);
		wsprintf(tcWriteData, "%d", m_bEnableRC);
		WritePrivateProfileString("SAVEDDATA", "EnableRC", tcWriteData, tcIniFile);
	}
}

void CVidzRadioProdTestDlg::UpdateTestData()
{
	CString csDisplay;
	BOOL	bSensitiveTest;
	
	// Display tune to test frequency
	if(m_uiPresetFreq != 0)
	{
		csDisplay.Format("%d Mhz", m_uiPresetFreq);
		csDisplay.Insert((csDisplay.GetLength()-6), '.');
		SetDlgItemText(IDC_TUNETEST_FREQ, csDisplay);
	}
			
	// Load frequencies for sensitivity test
	if(m_uiSenStaFreq1 != 0 && m_uiSenStaFreq2 != 0 && m_uiSenStaFreq3 != 0)
	{
		// Load frequency for 1st frequency
		csDisplay.Format("%d Mhz", m_uiSenStaFreq1);
		csDisplay.Insert((csDisplay.GetLength()-6), '.');
		SetDlgItemText(IDC_SENSTA1_FREQ, csDisplay);
		// Load frequency for 2nd frequency
		csDisplay.Format("%d Mhz", m_uiSenStaFreq2);
		csDisplay.Insert((csDisplay.GetLength()-6), '.');
		SetDlgItemText(IDC_SENSTA2_FREQ, csDisplay);
		// Load frequency for 3rd frequency
		csDisplay.Format("%d Mhz", m_uiSenStaFreq3);
		csDisplay.Insert((csDisplay.GetLength()-6), '.');
		SetDlgItemText(IDC_SENSTA3_FREQ, csDisplay);
				
		bSensitiveTest = TRUE;
	}
	
	// Show the search starting frequency
	if(m_uiSrFrequency != 0)
	{
		// Load frequency
		csDisplay.Format("Start from: %d Mhz", m_uiSrFrequency);
		csDisplay.Insert((csDisplay.GetLength()-6), '.');
		SetDlgItemText(IDC_SEARCH_FREQ, csDisplay);
	}
	// Show the searching direction
	if(m_uiSrDirection == 0)
		SetDlgItemText(IDC_SEARCH_RS, "Search Up");
	else if(m_uiSrDirection == 1)
		SetDlgItemText(IDC_SEARCH_RS, "Search Down");
		
	// Display the button we are testing
	DisplayRCMessage(m_uiRemoteChoice);
	
	// If all test data are loaded, set the bool variable to true
	if(m_uiPresetFreq !=0 && bSensitiveTest && m_uiSrFrequency !=0 
		&& m_uiSrDirection != -1 && m_uiRemoteChoice != -1 
		&& m_uiCurFirmVer != 0)
		m_bDataLoaded = TRUE;
	else
		m_bDataLoaded = FALSE;
}

void CVidzRadioProdTestDlg::PlayTestResultSound(INT iTest)
{
	// "Enable Sound" checkbox is not checked
	if(!m_bEnableSound)
		return;
	
	// "Enable Sound" checkbox is checked, play respective sound
	CString	csResult;
	
	GetDlgItemText(iTest, csResult);

	// We use the SND_ASYNC flag so that we can play another sound before the
	// previous sound ends
	if(csResult.Compare("Test Passed") == 0)
		PlaySound("wavpass", NULL, SND_FILENAME|SND_ASYNC);
	else if(csResult.Compare("Test Failed") == 0)
			// This line replaces the for loop below to play the "fail" sound once
			PlaySound("wavfail", NULL, SND_FILENAME|SND_ASYNC);
			/*for(int i=0; i<5; i++)	
			{
				if(PlaySound("wavpass", NULL, SND_FILENAME|SND_ASYNC))
				Sleep(100);
			}*/
}

BOOL CVidzRadioProdTestDlg::ProbeAllTestStates()
{
	if(m_bTuneTest && m_bSTPinTest && m_bSenTest && m_bSearchTest && m_bAuLeftTest
		&& m_bAuRightTest && m_bAuBothTest && m_bLEDGreen && m_bLEDRed && m_bRCTest)
		return TRUE;
	else
		return FALSE;
}

BOOL CVidzRadioProdTestDlg::PreTranslateMessage(MSG* pMsg) 
{
	// We include this function to prevent the dialog from receiving the
	// "Enter" key so that it does not exit when the "Clear message" key
	// is being pressed
	return 0;
	//return CDialog::PreTranslateMessage(pMsg);
}

/************************************************************************/
/*							Mixer Functions								*/
/************************************************************************/
VOID CVidzRadioProdTestDlg::CreateMixerObj()
{
	// Check if there are any mixer devices in the system
	if(mixerGetNumDevs() > 0)
	{
		// There is at least one mixer device. Use mixerOpen to open the mixer device.
		// This function retrieve a device handle, which can be used to identify the
		// opended mixer device when using other audio mixer functions.
		// MxId is '0' to show that we want to open the first mixer device that is 
		// detected on the system. fdwOpen is CALLBACK_NULL to show that no callback
		// mechanism is used.
		m_mmr = mixerOpen(&m_hmixer, 0, 0, 0, CALLBACK_NULL);
		if(m_mmr != MMSYSERR_NOERROR )
			OutputDebugString("mixerOpen\n");
		
		// We use mixerGetLineInfo() to retrieve a dwLineID
		// where the componentType member of the MIXERLINE structure is
		// MIXERLINE_COMPONENTTYPE_SRC_LINE or MIXERLINE_COMPONENTTYPE_DST_SPEAKERS.
		MIXERLINE mixerLine;
		mixerLine.cbStruct = sizeof(MIXERLINE);
		mixerLine.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_SPEAKERS;
		m_mmr = mixerGetLineInfo((HMIXEROBJ) m_hmixer, &mixerLine, MIXER_OBJECTF_HMIXER|
			MIXER_GETLINEINFOF_COMPONENTTYPE);
		if(m_mmr != MMSYSERR_NOERROR )
			OutputDebugString("mixerGetLineInfo\n");
		
		// mixerGetLineControls() retrieve a MIXERCONTROL struct with the control 
		// type stated in the dwControlType member of a MIXERLINECONTROLS struct.
		// The MIXERCONTROL struct contains a controlID which can identify the 
		// attribute of the mixer that we need to control (Volume in this case).
		MIXERCONTROL		mixerControl;
		MIXERLINECONTROLS	mixerLineControl;
		mixerLineControl.cbStruct = sizeof(MIXERLINECONTROLS);
		mixerLineControl.cbmxctrl = sizeof(MIXERCONTROL);
		mixerLineControl.pamxctrl = &mixerControl;
		mixerLineControl.dwLineID = mixerLine.dwLineID;
		mixerLineControl.dwControlType	= MIXERCONTROL_CONTROLTYPE_VOLUME;
		mixerLineControl.cControls		= 1;
		m_mmr = mixerGetLineControls((HMIXEROBJ) m_hmixer, &mixerLineControl,
			MIXER_GETLINECONTROLSF_ONEBYTYPE);
		if(m_mmr != MMSYSERR_NOERROR )
			OutputDebugString("mixerGetLineControls\n");
		
		// Prepare Data structure to set and get Line In volume
		m_mxCtrlDl.cbStruct = sizeof(MIXERCONTROLDETAILS);
		m_mxCtrlDl.dwControlID = mixerControl.dwControlID;
		m_mxCtrlDl.cChannels = mixerLine.cChannels;
		m_mxCtrlDl.cMultipleItems = 0;
		m_mxCtrlDl.cbDetails = sizeof(MIXERCONTROLDETAILS_UNSIGNED);
		m_mxCtrlDl.paDetails = m_mxCtrlDlUS;
	}
	else
		// No mixer devices in system, output debug msg and exit
		OutputDebugString("mixerGetNumDevs < 0\n");
}


VOID CVidzRadioProdTestDlg::SetMixerBal(BALANCE bal)
{
	DWORD	dwLeftVol, dwRightVol, dwCurVol;
	
	/* Background Info
	In a stereo line, there are two channels, the left and right channels. The
	balance of the volume is set by adjusting the left and right volume 
	accordingly. This means that if both the left and right volume are equeal,
	the balance is in the center. If the left volume is only half of the right
	volume, then the balance is halfway between the center and left. Therefore,
	when adjusting the balance, we need to know what is the current volume so that
	we can adjust the left and right volumes accordingly.
	*/
	
	// Check the status of the volume balance
	GetMixerBal(&dwLeftVol, &dwRightVol);
	
	// Get the current volume regardless of balance
	if(dwLeftVol == dwRightVol || dwLeftVol > dwRightVol)
		dwCurVol = dwLeftVol;
	else if(dwRightVol > dwLeftVol)
		dwCurVol = dwRightVol;
	
	switch(bal)
	{
	case LEFT:
		m_mxCtrlDlUS[0].dwValue = dwCurVol*655;
		m_mxCtrlDlUS[1].dwValue = 0;
		break;
	case RIGHT:
		m_mxCtrlDlUS[0].dwValue = 0;
		m_mxCtrlDlUS[1].dwValue = dwCurVol*655;
		break;
	case CENTER:
		m_mxCtrlDlUS[0].dwValue = dwCurVol*655;
		m_mxCtrlDlUS[1].dwValue = dwCurVol*655;
		break;
	}
	
	m_mmr = mixerSetControlDetails((HMIXEROBJ) m_hmixer, &m_mxCtrlDl, 
		MIXER_SETCONTROLDETAILSF_VALUE);
	if (MMSYSERR_NOERROR != m_mmr)
		OutputDebugString("mixerSetControlDetails\n");
}


VOID CVidzRadioProdTestDlg::GetMixerBal(DWORD* dwLeft, DWORD* dwRight)
{
	// Retrieved the current volume	
	m_mmr = mixerGetControlDetails((HMIXEROBJ) m_hmixer, &m_mxCtrlDl, 
		MIXER_SETCONTROLDETAILSF_VALUE);
	if (MMSYSERR_NOERROR != m_mmr)
		OutputDebugString("mixerSetControlDetails\n");
	
	*dwLeft		= (m_mxCtrlDlUS[0].dwValue)/655;
	*dwRight	= (m_mxCtrlDlUS[1].dwValue)/655;
}
